// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    DummyDataOverwriteDTO,
} from '../models';

export interface DeleteRegelungsvorhaben1Request {
    id: string;
}

export interface GenerateBundestagDataRequest {
    dummyDataOverwriteDTO?: DummyDataOverwriteDTO;
}

/**
 * no description
 */
export class DataControllerApi extends BaseAPI {

    /**
     * Löscht ein Regelungsvorhaben und die damit verknüpften Daten
     * Löscht ein Regelungsvorhaben
     */
    deleteRegelungsvorhaben1({ id }: DeleteRegelungsvorhaben1Request): Observable<void>
    deleteRegelungsvorhaben1({ id }: DeleteRegelungsvorhaben1Request, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteRegelungsvorhaben1({ id }: DeleteRegelungsvorhaben1Request, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteRegelungsvorhaben1');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/data/rv/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Generiert Daten für den Bundesrat.
     * Generiert Daten für den Bundesrat.
     */
    generateBundesratData(): Observable<boolean>
    generateBundesratData(opts?: OperationOpts): Observable<AjaxResponse<boolean>>
    generateBundesratData(opts?: OperationOpts): Observable<boolean | AjaxResponse<boolean>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<boolean>({
            url: '/data/generatebundesratdata/',
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Generiert Daten für den Bundestag.
     * Generiert Daten für den Bundestag.
     */
    generateBundestagData({ dummyDataOverwriteDTO }: GenerateBundestagDataRequest): Observable<boolean>
    generateBundestagData({ dummyDataOverwriteDTO }: GenerateBundestagDataRequest, opts?: OperationOpts): Observable<AjaxResponse<boolean>>
    generateBundestagData({ dummyDataOverwriteDTO }: GenerateBundestagDataRequest, opts?: OperationOpts): Observable<boolean | AjaxResponse<boolean>> {

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<boolean>({
            url: '/data/generatebundestagdata/',
            method: 'PUT',
            headers,
            body: dummyDataOverwriteDTO,
        }, opts?.responseOpts);
    };

}
